
/*
to compile this file, fix the MouseAPI.h in the "HID-Project"
like:
-----------
class MouseAPI
{
public:
  inline MouseAPI(void);
...
  virtual void SendReport(void* data, int length) = 0;

  inline void setButtons(uint8_t b) { _buttons = b; } //insert this line

protected:
...
-----------
*/

#include "HID-Project.h"

int counter;
int counter3;
byte mode;
int sync;
KeyboardKeycode key1;
KeyboardKeycode key2;
KeyboardKeycode key3;
KeyboardKeycode key4;
KeyboardKeycode key5;
KeyboardKeycode key6;
KeyboardKeycode key7;
byte modifierkey;
byte mx;
byte my;
byte mw;
byte mbutton;

void setup() {
  delay(1000); //wait for re-programming

  counter = 0;
  counter3 = 0;
  mode = 0;
  sync = 0;
  key1 = (KeyboardKeycode)0;  key2 = (KeyboardKeycode)0;  key3 = (KeyboardKeycode)0;
  key4 = (KeyboardKeycode)0;  key5 = (KeyboardKeycode)0;  key6 = (KeyboardKeycode)0;
  modifierkey = 0;
  mx = 0; my = 0; mw = 0; mbutton = 0;

  Serial1.begin(9600);
  BootKeyboard.begin();
  Mouse.begin();
}

void readbuf() {
  if ( Serial1.available() >= 12) {
    //read
    mode = Serial1.read(); //sync(6bit) | mode(2bit)
    key1 = (KeyboardKeycode)Serial1.read(); //pressed key 1
    key2 = (KeyboardKeycode)Serial1.read(); //pressed key 2
    key3 = (KeyboardKeycode)Serial1.read(); //pressed key 3
    key4 = (KeyboardKeycode)Serial1.read(); //pressed key 4
    key5 = (KeyboardKeycode)Serial1.read(); //pressed key 5
    key6 = (KeyboardKeycode)Serial1.read(); //pressed key 6
    modifierkey = Serial1.read(); //modifier key
    mbutton = Serial1.read(); //mouse button
    mx = Serial1.read(); //mouse x
    my = Serial1.read(); //mouse y
    mw = Serial1.read(); //mouse w
    Serial1.write(counter);//response
    sync = (mode >> 2);
    mode = (mode & 3);
    counter3 = 3;
  }
}
void loop() {
  if (mode == 0) {
    //normal mode
    readbuf();
  } else if (mode == 1) {
    //detect sync position mode
    readbuf();
    key1 = (KeyboardKeycode)(counter + 4);
    key2 = (KeyboardKeycode)0;  key3 = (KeyboardKeycode)0;
    key4 = (KeyboardKeycode)0;  key5 = (KeyboardKeycode)0;  key6 = (KeyboardKeycode)0;
    modifierkey = 0;
    mx = 0; my = 0; mw = 0; mbutton = 0;
  } else if (mode == 2) {
    //sync mode
    if (counter > sync) {
      if ( ((counter - sync) & 1) > 0) readbuf();
    } else if ( counter < sync) {
      if ( ((counter + 25 - sync) & 1) > 0) readbuf();
    }
  } else if (mode == 3) {
    //type mode (3 count)
    if (counter3 <= 0) readbuf();
  }

  BootKeyboard.removeAll();
  BootKeyboard.add(key1);
  BootKeyboard.add(key2);
  BootKeyboard.add(key3);
  BootKeyboard.add(key4);
  BootKeyboard.add(key5);
  BootKeyboard.add(key6);
  if (modifierkey & 0x1) BootKeyboard.add((KeyboardKeycode)0xE0); //Left Ctrl
  if (modifierkey & 0x2) BootKeyboard.add((KeyboardKeycode)0xE1); //Left Shift
  if (modifierkey & 0x4) BootKeyboard.add((KeyboardKeycode)0xE2); //Left Alt
  if (modifierkey & 0x8) BootKeyboard.add((KeyboardKeycode)0xE3); //Left Win
  if (modifierkey & 0x10) BootKeyboard.add((KeyboardKeycode)0xE4); //Right Ctrl
  if (modifierkey & 0x20) BootKeyboard.add((KeyboardKeycode)0xE5); //Right Shift
  if (modifierkey & 0x40) BootKeyboard.add((KeyboardKeycode)0xE6); //Right Alt
  if (modifierkey & 0x80) BootKeyboard.add((KeyboardKeycode)0xE7); //Right Win

  unsigned int t0 = millis();

  Mouse.setButtons(mbutton);
  Mouse.move(mx, my, mw);
  BootKeyboard.send();

  unsigned int t1 = millis();

  //200 msec counter
  if (t1 - t0 > 12) {
    //16msec
    counter = counter + 2;
  } else {
    //8msec
    counter = counter + 1;
  }
  while (counter >= 25) counter -= 25;
  if (counter3 > 0) counter3 -= 1;
}
